#include <pthread.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>


struct message
{
	char* text;
	int counter;
};



void readInputs(int *firstParameter, struct message *secondParameter)
{
	secondParameter->text = malloc(sizeof(char)*100);
	//secondPArameter initialization
	memset(secondParameter->text, '\0', sizeof(char)*100);

	printf("Insert n\n");
	scanf("%d", firstParameter);

	printf("Insert s\n");
	scanf("%s", secondParameter->text);

	printf("Insert k\n");
	scanf("%d", &secondParameter->counter);

	printf("\n\n");

	return;
}



void *firstChild(void* par)
{
	int result = 1;
  int number = *(int*)par;
	int *resultValue = malloc(sizeof(int));


	//compute number!
	for (; number > 0; number--)
		result *= number;
  *resultValue = result;

	printf("Thread 1: returning\n");
	//A POSIX thread function should only return void*.
	pthread_exit(resultValue);
}



void *secondChild(void* par)
{
	struct message receivedMessage = *(struct message*)par;


	for (; receivedMessage.counter > 0; receivedMessage.counter--)
	{
		printf ("%s: %d\n", receivedMessage.text, receivedMessage.counter);
		sleep(1);
	}

	printf("Thread 2: returning\n");
	pthread_exit(NULL);
}



int main (int argc, char * argv[])
{
	pthread_t threads[2];
	int firstParameter;
	int ret;
	int i;
	void* returnValue;
	struct message secondParameter;

	readInputs(&firstParameter, &secondParameter);

	//create thread #1
	ret = pthread_create(&threads[0], NULL, firstChild, (void*) &firstParameter);
	if (ret != 0)
	{
		printf("Error in creationg the thread\n");
		printf("errno message: %s\n", strerror(errno));

		exit(-1);
	}
	printf ("main: created thread 1\n");

	//create thread #2
	ret = pthread_create(&threads[1], NULL, secondChild, (void*) &secondParameter);
	if (ret != 0)
	{
		printf("Error in creationg the thread\n");
		printf("errno message: %s\n", strerror(errno));

		exit(-1);
	}
	printf("main: created thread 2\n");


	for (i=0; i < 2; i++)
	{
		ret = pthread_join(threads[i], &returnValue);
		if (ret != 0)
		{
			printf("Error in pthread_join()\n");
			printf("errno message: %s\n", strerror(errno));

			exit(-1);
		}
		printf ("main: completed join with thread #%d.", i + 1);

		if (returnValue != NULL)
			//value returned by thread #1 (factorial)
			printf(" Returned value = %d\n", *(int*)returnValue);
		else
			//value returned by thread #2 (timer)
			printf("\n");
	}

	free(returnValue);
	free(secondParameter.text);

	printf("main: returning\n");
}
